%	Appendix B
%	The Matlab6.0 code of High Dynamic Range image
%	display using Level Set method proposed in this
%	paper is given below.
%		TOO MANY VARIABLES ARE PASSED TO IMGMANF() AT LINE 27
%		THE TIFFWRITE STATEMENT REFERS TO AN UNKNOWN FILENAME 
%			- 'LHRFILENAME'
function [ ]=lsHDRC(filename, nstep)
%set up parameters
%clear all;	
%Recommened 
%	program 'DEFAULT:' statements included by me for historical reasons - jlj
gamma = 2.0;				% DEFAULT: 2.0 
delt = 0.15;%0.15;% 			DEFAULT: 0.15
%nstep = 14;%10 ;10;60;		% DEFAULT: 14
nnstep = nstep + 1;
sensitivity = 8.0;%3.0; %8.0; 	%for edge% DEFAULT: 8.0
vision = 1;% 0.73;				% for vision; % DEFAULT: 1.0
              % the smaller, the more accurate of the vision to peer the image
							% default = 0.73
proran = 0.5;          
	CIE_rf=.265074126; CIE_gr=.670114631;
	CIE_br=.064811243; MIN_LUM = 1.0e-3;
	%	PAGE BREAK ================================================================
%Read in the luminance image and store in r, g, b
%	[r g b]=rgbereadrgb(filename);
	rgbeimage=radread(filename);
	r=rgbeimage(:,:,1);
	g=rgbeimage(:,:,2);
	b=rgbeimage(:,:,3);
%Get luminance value
	im = CIE_rf*r + CIE_gr*g + CIE_br*b;
	im(find(im==0))=MIN_LUM;
% transform luminance into logarithm domain.
	loglum = log(im);
% extract profile using LS =>prologlum
	prologlum = imgmanf(loglum,delt,nstep,nnstep,sensitivity);
	meanlum = exp(median(loglum(:)));
	n = vision;
	factor = exp(prologlum).^(n-1) ./(exp(prologlum).^n + (meanlum/0.18)^n);
%recover low dynamic range image =>r,g,b
	r1 = r .*factor;g1 = g .*factor;b1 = b .*factor;
	r1 = power(r1,1/gamma);g1 = power(g1,1/gamma);b1 = power(b1,1/gamma);
	clear factor n meanlum loglum prologlum im CIE_rf ...
	CIE_br proran vision sensitivity nstep nnstep delt gamma rgbeimage ;
%	image=[r g b];
%	clear r g b;
	
%show compressed image
%tiffwrite(r1,g1,b1,filename,tif);
filename2=[filename 'tif'];
imwrite(image, filename2, 'tif','Compression', 'packbits');

%OK

%High Dynamic Range Image Display Using Level Set Framework
%
%Ruifeng Xu
%University of Central Florida
%rxu@cs.ucf.edu
%
%Sumanta N. Pattanaik
%University of Central Florida
%sumant@cs.ucf.edu

