% main()  - HDR compression using Level Set theory
% Ruifeng Xu

%input
%%%%%%%%%%%%%%%%%%%%%%%
%Recommened 
radread(filename);
gamma = 2.0;
delt = 0.15;%0.15;
nsteps = 14;%10 ;%10;%60;
nnsteps = nsteps + 1;
sensitivity = 8.0; %3.0; %8.0; %for edge
vision = 1;% 0.73; % for vision; 
              % the smaller, the more accurate of the vision to peer the image
              % default = 0.73
proran = 0.5;          
              
%%%%%%%%%%%%%%%%%%%%%%%
CIE_rf=.265074126;
CIE_gr=.670114631;
CIE_br=.064811243;
MIN_LUM = 1.0e-3;

if(exist('rgbefilename') ~= 1)
    fprintf(1,'main2 rgbefilename lhrfilename');
    return;
end
if(exist('lhrfilename') ~= 1)
    fprintf(1,'main2 rgbefilename lhrfilename');
    return;
end
% fprintf(1,'RAT:%f\n',RAT);
fprintf(1,'delt:%f\n',delt);
fprintf(1,'nsteps:%d\n',nsteps);
fprintf(1,'sensitivity:%f\n',sensitivity);
fprintf(1,'vision power:%f\n',vision);

%%%%%%%%%%%%%%%%%%%%  Read in the luminance image and store in r, g, b
fprintf(1,'load RGBE data...\n');
%rgbefilename = 'home014.mat'
%load(rgbefilename);
[r g b]=rgbereadrgb(rgbefilename);
fprintf(1,'file size:%dX%d\n', size(r));
%%%%%%%%%%%%%%%%%%%% Get luminance value 
fprintf(1,'get luminance value...\n');
% im = 0.3*r+0.6*g+0.1*b;
im = CIE_rf*r + CIE_gr*g + CIE_br*b;
im(find(im==0))=MIN_LUM;

% %try another method
% RGB2XYZ = [0.5141364 0.3238786  0.16036376;
% 		   0.265068  0.67023428 0.06409157;
% 		   0.0241188 0.1228178  0.84442666];
% XYZ2RGB = [2.5651    -1.1665    -0.3986   ;
% 		   -1.0217    1.9777     0.0439   ;
% 		    0.0753   -0.2543    1.1892      ];
% X = r*RGB2XYZ(1,1) + g*RGB2XYZ(1,2) + b*RGB2XYZ(1,3);
% Y = r*RGB2XYZ(2,1) + g*RGB2XYZ(2,2) + b*RGB2XYZ(2,3);
% Z = r*RGB2XYZ(3,1) + g*RGB2XYZ(3,2) + b*RGB2XYZ(3,3);
% W=X+Y+Z;
% x = zeros(size(W));
% y = zeros(size(W));
% for row=1:size(W,1)
%     for col = 1:size(W,2)
%         if W(row,col)>0
%             Y(row,col) = Y(row,col);
%             x(row,col) = X(row,col) ./ W(row,col);
%             y(row,col) = Y(row,col) ./ W(row,col);
%         else
%             Y(row,col) = 0;
%             x(row,col) = 0;
%             y(row,col) = 0;
%         end
%     end
% end
% 
% im = Y;
% im(find(im==0))=MIN_LUM;

%%%%%%%%%%%%%%%%%%%%%%%%%%  transform luminance into logarithm domain.
fprintf(1, 'transform luminance into logarithm domain...\n');
loglum = log(im);

%%%%%%%%%%%%%%%%%%%%%%%%%   extract profile using LS    =>prologlum
fprintf(1,'extract profile using LS...\n');
%surf(loglum);
prologlum = imgmanf(loglum,delt,nsteps,nnsteps,sensitivity);
%figure;showim(prologlum);

detlum=exp(loglum-prologlum);

meanlum = exp(median(loglum(:)));
%detmeanlum = median(detlum(:));
n = vision;
%nn = 1.0;
factor = exp(prologlum).^(n-1) ./(exp(prologlum).^n + (meanlum/0.18)^n);
%factor = (proran*exp(prologlum).^n ./(exp(prologlum).^n + (meanlum/0.18)^n)+0.5-proran/2)./exp(prologlum);
%factor = (proran*exp(prologlum).^n ./(exp(prologlum).^n + (meanlum/0.18)^n))./exp(prologlum);
%factor = (detlum.^nn) ./ ((detlum.^nn) + (detmeanlum/0.18)^nn)  .*  (exp(prologlum).^n) ./ ( (exp(prologlum).^n) + ((meanlum/0.18)^n)) ./ im;

fprintf(1,'recover the compressed image...\n');
r1 = r .*factor;
g1 = g .*factor;
b1 = b .*factor;

% meanlum = exp(median(loglum(:)));
% detmeanlum = median(detlum(:));
% n = 0.5;
% %Y = im .* (exp(prologlum).^(n-1)) ./ ( (exp(prologlum).^n) + ((meanlum/0.18)^n));
% Y = (detlum.^n) ./ ((detlum.^n) + (detmeanlum/0.18)^n)  .*  (exp(prologlum).^n) ./ ( (exp(prologlum).^n) + ((meanlum/0.18)^n));
% 
% for row=1:size(W,1)
%     for col = 1:size(W,2)
%         if Y(row,col) > 0.0 & x(row,col)>0.0 & y(row,col)>0.0
%             X(row,col) = x(row,col) * Y(row,col) / y(row,col);
%             Z(row,col) = X(row,col)/x(row,col) - X(row,col) - Y(row,col);
%         else
%             X(row,col) = 0.0;
%             Z(row,col) = 0.0;
%         end
%     end
% end
% r = X*XYZ2RGB(1,1) + Y*XYZ2RGB(1,2) + Z*XYZ2RGB(1,3);
% g = X*XYZ2RGB(2,1) + Y*XYZ2RGB(2,2) + Z*XYZ2RGB(2,3);
% b = X*XYZ2RGB(3,1) + Y*XYZ2RGB(3,2) + Z*XYZ2RGB(3,3);

fprintf(1,'adjust gamma with %f\n', gamma);
r1 = power(r1,1/gamma);
g1 = power(g1,1/gamma);
b1 = power(b1,1/gamma);

%%%%%%%%%%%%%%%%%%%%%%%    show compressed image
fprintf(1,'write into %s... \n', lhrfilename);
%RGBEwriteRGB(r,g,b,lhrfilename);
% r(find(r>1))=1; g(find(g>1))=1; b(find(b>1))=1;
tiffwrite(r1,g1,b1,lhrfilename);
% RGBEwriteRGB(r,g,b,lhrfilename);

%%%OK
fprintf(1,'OK! \n');